//-----------------------------------------------------------------------------
// cubic spline 
// Copyright (c) 2007,2008  N099
//-----------------------------------------------------------------------------
#include <xmmintrin.h>

#ifndef PIXEL_YC
typedef	struct {
    short y,cb,cr;
} PIXEL_YC;
#endif

#include "spl.h"

//svZ̏d݂𓾂
void spl_update_weight(__m128 *w, int n)
{
    int i;
    __m128 xm0;
    static const __m128 xc0 = { 0.25f, 0.25f, 0.25f, 0.25f };
    static const __m128 xc1 = { 1.0f, 1.0f, 1.0f, 1.0f };
    static const __m128 xc2 = { 4.0f, 4.0f, 4.0f, 4.0f };

    //d݂ɂ͈ʒuItZbguȂ
    xm0 = xc0; 
    _mm_store_ps((float*)w++, xm0);
    
    for(i=1; i<n; ++i){
#if 1
        xm0 = _mm_div_ps(xc1, _mm_sub_ps(xc2, xm0));
#else
        xm0 = _mm_rcp_ps(_mm_sub_ps(xc2, xm0));
#endif
        _mm_store_ps((float*)w++, xm0);
    }
}

//PIXEL_YC->floatϊ{2W̌vZij
void spl_make_ddh_yc(const PIXEL_YC *yc, __m128 *xsrc, const __m128 *xw, int w)
{
    int i;
    __m128 xd0,xr0,xm0;
    __m128 xyc0,xyc1,xyc2;
    static const __m128 xc0 = { 6.0f, 6.0f, 6.0f, 6.0f };

    //g̓sA[̊OɗאڃsNZRs[
    xyc1 = xyc0 = _mm_cvtpi16_ps(*(const __m64*)(yc++));

    xd0 = _mm_setzero_ps();
    _mm_store_ps((float*)xsrc++, xyc0);
    _mm_store_ps((float*)xsrc++, xd0);

    //i[Rs[̌ʁAvZvf w+2-2==w ɂȂj
    for(i=0; i<w-1; ++i){
        xyc2 = _mm_cvtpi16_ps(*(const __m64*)(yc++));
        xr0  = _mm_load_ps((const float*)xw++);

        xyc0 = _mm_sub_ps(xyc1, xyc0);
        xm0  = _mm_sub_ps(xyc2, xyc1);
        xm0  = _mm_sub_ps(xm0, xyc0);
        xm0  = _mm_mul_ps(xm0, xc0);

        xyc0 = xyc1;
        xyc1 = xyc2;

        xm0 = _mm_sub_ps(xm0, xd0);
        xd0 = _mm_mul_ps(xm0, xr0);
        _mm_store_ps((float*)xsrc++, xyc0);
        _mm_store_ps((float*)xsrc++, xd0);
    }

    //E[
    xr0 = _mm_load_ps((const float*)xw--);
    xm0 = _mm_sub_ps(xyc0, xyc1);
    xm0 = _mm_mul_ps(xm0, xc0);
    xm0 = _mm_sub_ps(xm0, xd0);
    xd0 = _mm_mul_ps(xm0, xr0);
    _mm_store_ps((float*)xsrc++, xyc1);
    _mm_store_ps((float*)xsrc++, xd0);
    _mm_store_ps((float*)xsrc++, xyc1);
    _mm_store_ps((float*)xsrc, _mm_setzero_ps());
     
    //t
    xsrc -= 4;
    for(i=0; i<w-1; ++i){
        xm0 = _mm_load_ps((float*)xsrc);
        xd0 = _mm_mul_ps(xd0, xr0);
        xr0 = _mm_load_ps((const float*)xw--);
        
        xd0 = _mm_sub_ps(xm0, xd0);
        _mm_store_ps((float*)xsrc, xd0);
        xsrc -= 2;
    }
}

//Ԓl߂PIXEL_YCɕϊij
void spl_hinterporate_yc(PIXEL_YC *yc, const __m128 *xsrc, int w, int rw)
{
    int i,p;
    __m128 xs0,xs1,xd0,xd1,xa1,xb1,xa3,xb3,xdp;
    static const __m128 xc0 = { 1.0f/6.0f, 1.0f/6.0f, 1.0f/6.0f, 1.0f/6.0f };
    static const __m128 xc1 = { 0.5f, 0.5f, 0.5f, 0.5f };
    
    //sb`̌vZ
    xa1 = _mm_cvtsi32_ss(_mm_setzero_ps(), w);
    xb1 = _mm_cvtsi32_ss(_mm_setzero_ps(), rw);
    xdp = _mm_div_ss(xa1, xb1);
    
    for(i=0; i<rw; ++i){
        xa3 = _mm_cvtsi32_ss(xdp, i);
        xa3 = _mm_add_ss(xa3, xc1);

        xa1 = _mm_mul_ss(xdp, xa3);
        xa1 = _mm_add_ss(xa1, xc1);
        xb1 = _mm_add_ss(xc1, xc1);
        p = _mm_cvttss_si32(xa1);

        xs0 = _mm_load_ps((const float*)(xsrc + p*2));
        xd0 = _mm_load_ps((const float*)(xsrc + p*2 + 1));
        xs1 = _mm_load_ps((const float*)(xsrc + p*2 + 2));
        xd1 = _mm_load_ps((const float*)(xsrc + p*2 + 3));
        
        xa3 = _mm_cvtsi32_ss(xa3, p);
        xb1 = _mm_sub_ss(xb1, xa1);
        xa1 = _mm_sub_ss(xa1, xa3);
        xb1 = _mm_add_ss(xb1, xa3);

        xb1 = _mm_shuffle_ps(xb1, xb1, 0);
        xa1 = _mm_shuffle_ps(xa1, xa1, 0);
        
        xb3 = _mm_mul_ps(_mm_mul_ps(xb1, xb1), xb1);
        xa3 = _mm_mul_ps(_mm_mul_ps(xa1, xa1), xa1);
        xb3 = _mm_sub_ps(xb3, xb1);
        xa3 = _mm_sub_ps(xa3, xa1);
        
        xb1 = _mm_mul_ps(xb1, xs0);
        xa1 = _mm_mul_ps(xa1, xs1);
        xb3 = _mm_mul_ps(xb3, xd0);
        xa3 = _mm_mul_ps(xa3, xd1);
        
        xb1 = _mm_add_ps(xb1, xa1);
        xb3 = _mm_add_ps(xb3, xa3);
        xb3 = _mm_mul_ps(xb3, xc0);
        xb1 = _mm_add_ps(xb1, xb3);
        
        *(__m64*)yc++ = _mm_cvtps_pi16(xb1);
    }
}

//PIXEL_YC->floatϊ{2W̌vZij
#define PF_DIST_V 6
void spl_make_ddv_yc(const __m64 *myc, __m128 *xsrc, const __m128 *xw, int h, int ws)
{
    int i;
    __m128 xd0,xr0,xm0;
    __m128 xyc0,xyc1,xyc2;
    static const __m128 xc0 = { 6.0f, 6.0f, 6.0f, 6.0f };

#if PF_DIST_V > 0
    for(i=0; i<PF_DIST_V; ++i){
        _mm_prefetch(myc + i * ws, _MM_HINT_T0);
    }
#endif

    /* ㉺[sNZ͗אڃf[^Rs[Ă(h = h+2) */
    xyc2 = xyc1 = xyc0 = _mm_cvtpi16_ps(*myc);
    myc += ws;

    xd0 = _mm_setzero_ps();
    _mm_store_ps((float*)xsrc++, xyc0);
    _mm_store_ps((float*)xsrc++, xd0);

    //
    for(i=0; i<h-1; ++i){
#if PF_DIST_V > 0
        _mm_prefetch(myc + PF_DIST_V * ws, _MM_HINT_T0);
#endif
        xyc2 = _mm_cvtpi16_ps(*myc);
        xr0  = _mm_load_ps((const float*)xw++);
        myc += ws;

        xyc0 = _mm_sub_ps(xyc1, xyc0);
        xm0  = _mm_sub_ps(xyc2, xyc1);
        xm0  = _mm_sub_ps(xm0, xyc0);
        xm0  = _mm_mul_ps(xm0, xc0);

        xyc0 = xyc1;
        xyc1 = xyc2;

        xm0 = _mm_sub_ps(xm0, xd0);
        xd0 = _mm_mul_ps(xm0, xr0);
        _mm_store_ps((float*)xsrc++, xyc0);
        _mm_store_ps((float*)xsrc++, xd0);
    }

    //[
    xr0 = _mm_load_ps((const float*)xw--);
    xm0 = _mm_sub_ps(xyc0, xyc1);
    xm0 = _mm_mul_ps(xm0, xc0);
    xm0 = _mm_sub_ps(xm0, xd0);
    xd0 = _mm_mul_ps(xm0, xr0);
    _mm_store_ps((float*)xsrc++, xyc1);
    _mm_store_ps((float*)xsrc++, xd0);
    _mm_store_ps((float*)xsrc++, xyc1);
    _mm_store_ps((float*)xsrc, _mm_setzero_ps());
     
    //t
    xsrc -= 4;
    for(i=0; i<h-1; ++i){
        xm0 = _mm_load_ps((float*)xsrc);
        xd0 = _mm_mul_ps(xd0, xr0);
        xr0 = _mm_load_ps((const float*)xw--);
        
        xd0 = _mm_sub_ps(xm0, xd0);
        _mm_store_ps((float*)xsrc, xd0);
        xsrc -= 2;
    }
}

//Ԓl߂PIXEL_YCɕϊij
void spl_vinterporate_yc(__m64 *myc, const __m128 *xsrc, int h, int rh, int ws)
{
    int i,p;
    __m128 xs0,xs1,xd0,xd1,xa1,xb1,xa3,xb3,xdp;
    static const __m128 xc0 = { 1.0f/6.0f, 1.0f/6.0f, 1.0f/6.0f, 1.0f/6.0f };
    static const __m128 xc1 = { 0.5f, 0.5f, 0.5f, 0.5f };

    //sb`̌vZ
    xa1 = _mm_cvtsi32_ss(_mm_setzero_ps(), h);
    xb1 = _mm_cvtsi32_ss(_mm_setzero_ps(), rh);
    xdp = _mm_div_ss(xa1, xb1);
    
    for(i=0; i<rh; ++i){
        xa3 = _mm_cvtsi32_ss(xdp, i);
        xa3 = _mm_add_ss(xa3, xc1);

        xa1 = _mm_mul_ss(xdp, xa3);
        xa1 = _mm_add_ss(xa1, xc1);
        xb1 = _mm_add_ss(xc1, xc1);
        p = _mm_cvttss_si32(xa1);

        xs0 = _mm_load_ps((const float*)(xsrc + p*2));
        xd0 = _mm_load_ps((const float*)(xsrc + p*2 + 1));
        xs1 = _mm_load_ps((const float*)(xsrc + p*2 + 2));
        xd1 = _mm_load_ps((const float*)(xsrc + p*2 + 3));
        
        xa3 = _mm_cvtsi32_ss(xa3, p);
        xb1 = _mm_sub_ss(xb1, xa1);
        xa1 = _mm_sub_ss(xa1, xa3);
        xb1 = _mm_add_ss(xb1, xa3);

        xb1 = _mm_shuffle_ps(xb1, xb1, 0);
        xa1 = _mm_shuffle_ps(xa1, xa1, 0);
        
        xb3 = _mm_mul_ps(_mm_mul_ps(xb1, xb1), xb1);
        xa3 = _mm_mul_ps(_mm_mul_ps(xa1, xa1), xa1);
        xb3 = _mm_sub_ps(xb3, xb1);
        xa3 = _mm_sub_ps(xa3, xa1);
        
        xb1 = _mm_mul_ps(xb1, xs0);
        xa1 = _mm_mul_ps(xa1, xs1);
        xb3 = _mm_mul_ps(xb3, xd0);
        xa3 = _mm_mul_ps(xa3, xd1);
        
        xb1 = _mm_add_ps(xb1, xa1);
        xb3 = _mm_add_ps(xb3, xa3);
        xb3 = _mm_mul_ps(xb3, xc0);
        xb1 = _mm_add_ps(xb1, xb3);

        *myc = _mm_cvtps_pi16(xb1);
        myc += ws;
    }
}

